VERSION 5.00
Begin VB.Form frmTutorMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Tutorial Lauflicht"
   ClientHeight    =   1668
   ClientLeft      =   3252
   ClientTop       =   1320
   ClientWidth     =   7908
   DrawStyle       =   6  'Innen ausgefllt
   FillColor       =   &H00C0C0FF&
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1668
   ScaleWidth      =   7908
   Begin VB.CommandButton cmdDimm 
      Caption         =   "Dim"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   1200
      Width           =   855
   End
   Begin VB.CommandButton cmdReceive 
      Caption         =   "Receive"
      Height          =   375
      Left            =   5760
      TabIndex        =   2
      Top             =   1200
      Width           =   855
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   375
      Left            =   6840
      TabIndex        =   1
      Top             =   1200
      Width           =   855
   End
   Begin VB.Timer timLLTimer 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   3000
      Top             =   1200
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   375
      Left            =   4680
      TabIndex        =   0
      Top             =   1200
      Width           =   855
   End
End
Attribute VB_Name = "frmTutorMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************************
' This is a plugin demonstration for DMXControl 2.9
' - forms module -
' You are allowed to use and adapt this code for your own plugin
' Frank Burghardt, Sept 2005
' www.dmxcontrol.de
'****************************************************************************

Option Explicit

Implements IDMXCTool

' Private WithEvents Storage As IDataStorage
Dim myViewmode As View          'excute or edit view

Dim mxstart, mystart As Integer 'Koordinaten Ursprung der Matrix
Dim mccx, mccy As Integer       'current selected cell coordinates(not pixel but cell numbers)
Dim mhight, mwidht As Integer   'size of drawing field
  
Dim mchcolor(1 To 4) As Integer  'fix colors of the 4 channels
Dim mblnHalfDensity As Boolean      'full or half density for cell edit mode

Private Function IDMXCTool_AskToSaveProjectData() As Boolean
  'should the plugin be asked to save data or configuration when
  'the project is changed.
  'Debug.Print "[frmTutorMaim] IDMXCTool_AskToSaveProjectData()"
  IDMXCTool_AskToSaveProjectData = False
End Function

Private Sub IDMXCTool_ClearProjectData()
  'msgbox ("[frmTutorMaim] IDMXCTool_ClearProjectData()")
End Sub

Private Sub IDMXCTool_LoadProjectData()
  'MsgBox ("[frmTutorMaim] IDMXCTool_LoadProjectData()")
End Sub

Private Sub IDMXCTool_SaveProjectData()
  'MsgBox ("[frmTutorMaim] IDMXCTool_SaveProjectData()")
End Sub

Private Property Let IDMXCTool_ViewMode(ByVal RHS As DMXCTypeLib.View)
  'Debug.Print "[frmTutorMaim] IDMXCTool_ViewMode"
  myViewmode = RHS
End Property

Private Sub initializeLEDMatrix()
Dim i, j As Integer
    For i = 1 To 60
        For j = 1 To 4
            gLED_matrix(i, j) = LED_off
        Next
    Next
    mchcolor(1) = 1 'VB-blue
    mchcolor(2) = 6 'VB-yellow
    mchcolor(3) = 4 'VB-red
    mchcolor(4) = 2 'VB-green
    mxstart = 200
    mystart = 240
    mhight = 800
    mwidht = 60 * 125
    
End Sub

Private Sub cmdStart_Click()
    
    If timLLTimer.Enabled Then
          timLLTimer.Enabled = False 'stop animation
          cmdStart.Caption = "Start"
    Else
        gcurSecond = 1
        gprevSecond = 60
        timLLTimer.Enabled = True  'start animation
        cmdStart.Caption = "Stop"
    End If
End Sub



Private Sub cmdDimm_Click()
' set global status for edit mode (half or full density) for selected LEDs
' switch between both edit modes
    If mblnHalfDensity Then
        cmdDimm.Caption = "Full"
    Else
        cmdDimm.Caption = "Dim"
    End If
    mblnHalfDensity = Not mblnHalfDensity
End Sub
Private Sub cmdDimmmer1_Click()
' set global status for edit mode (half or full density) for selected LEDs
' switch between both edit modes
  mblnHalfDensity = Not mblnHalfDensity
End Sub

Private Sub CmdReceive_Click()
'for Tutorial part 2 only
'switch between global status for send/receive mode

    gblnReceiveMode = Not gblnReceiveMode
    If gblnReceiveMode Then
        cmdReceive.Caption = "Receive"
    Else
        cmdReceive.Caption = "Send"
    End If
End Sub

Public Sub enlightChannel(ByVal Ch As Integer, ByVal Status As LED_status)
Dim i As Integer
        For i = 1 To 60
            gLED_matrix(i, Ch) = Status
            Call colorizeCurrentCell(i, Ch, True)
        Next
End Sub

Public Sub Form_Load()
' draw empty matrix
Dim X, Y As Long
Dim color As Long
 
    color = QBColor(15)
    initializeLEDMatrix
    
    ' draw empty black LED matrix field with white grids
    Line (mxstart - 30, mystart - 30)-(mxstart + mwidht + 30, mystart + mhight + 30), QBColor(0), BF

    For Y = 0 To 4
        Line (mxstart, mystart + Y * 200)-(mxstart + mwidht, mystart + Y * 200), color
    Next Y
    For X = 0 To 60
        Line (mxstart + X * 125, mystart)-(mxstart + X * 125, mystart + mhight), color
    Next X
    
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
' for editing the drawing field
' checks whether and which LED cell is selected
' new LED status is stored in LED matrix
If X > mxstart And X < mxstart + mwidht Then
    If Y > mystart And Y < mystart + mhight Then
       'mouse pointer is located in any cell
       Call ComputeCellNumber(X, Y) 'now cell number is stored in mccx and mccy
       If gLED_matrix(mccx, mccy) = LED_off Then
            If mblnHalfDensity Then
                gLED_matrix(mccx, mccy) = LED_dimmed
            Else
                gLED_matrix(mccx, mccy) = LED_on
            End If
        Else
            gLED_matrix(mccx, mccy) = LED_off
        End If
        Call colorizeCurrentCell(mccx, mccy, False)
    End If
End If
End Sub

Private Sub colorizeCurrentCell(ByVal cx As Integer, ByVal cy As Integer, ByVal activemode As Boolean)
' the current LED cell is colorized dependend on its LEDstatus
Dim xh, yh, eh, zh As Integer 'help variables
Dim ccolor%

xh = mxstart + (cx - 1) * 125   'x coordinate of current cell
yh = mystart + (cy - 1) * 200   'y coordinate of current cell
zh = 0                          ' help var for dimmed cell
eh = 0                          ' help var for animation mode
    If gLED_matrix(cx, cy) = LED_off Then
        ccolor = 0
    Else
        ccolor = mchcolor(cy) 'assign the fix color of related channel
    End If
If activemode And gLED_matrix(cx, cy) <> LED_off Then
    eh = 8 'if animation mode (active mode) then the color becomes more intensive
End If
If gLED_matrix(cx, cy) = LED_dimmed Then
    zh = 100  ' fill only half cell with color (reducing hight)
End If
    'fill the cell and draw the frame
    Line (xh, yh + zh)-(xh + 125, yh + 200), QBColor(ccolor + eh), BF
    Line (xh, yh)-(xh + 125, yh + 200), QBColor(15), B   'Frame
 
End Sub

Private Sub ComputeCellNumber(x1 As Single, y1 As Single)
    mccx = Int((x1 - mxstart) / 125) + 1
    mccy = Int((y1 - mystart) / 200) + 1
End Sub

Private Sub timLLTimer_Timer()
'after one second the timer initiates move to next position
Dim i As Integer

gprevSecond = gcurSecond
gcurSecond = (gcurSecond Mod 60) + 1

For i = 1 To 4
    'change status and color of current cells
        Call colorizeCurrentCell(gcurSecond, i, True)
    
    'restore color of previos cells
    If gLED_matrix(gprevSecond, i) <> LED_off Then
        Call colorizeCurrentCell(gprevSecond, i, False)
    End If
Next
TutorLLSetDMXvalue (gcurSecond)       'trigger sending of DMX values
Call SetStatusControlLight(gcurSecond, True)
Call SetStatusControlLight(gprevSecond, False)

End Sub

Private Sub SetStatusControlLight(ByVal col As Integer, ByVal mode As Boolean)
' shows current (time) position in animation
' the correponding status control light is switched on/off
Dim xh As Integer

xh = mxstart + (col - 1) * 125   'x coordinate of current cell

If mode Then
    'status control light on
    Line (xh + 40, 120)-(xh + 85, 160), QBColor(12), BF
Else
    'status control light off
    Line (xh + 40, 120)-(xh + 85, 160), QBColor(0), BF
End If
End Sub

Public Sub readTutorLLConfigurationData()
' read only configuration data - start address
' no special form is required for this demo plugin
Dim AddressText As String
Dim ok As Boolean
While Not ok
AddressText = InputBox$("Start Address:", "Demo Plugin Configuration")
    ok = True
    'make plausibility test
    If IsNumeric(AddressText) = False Then
      MsgBox Prompt:="Please enter an integer for start address!"
      ok = False
    End If
     If AddressText > 252 Then
      MsgBox Prompt:="Please insert a value lower than 252"
      ok = False
    End If
    
    '*********************************
    ' Hier msste Abfrage der Kanaleigenschaften erfolgen
    ' z.B. Prfung, ob die 4 Kanle txtStartAddr ... txtStartAddr+3 dimmbar sind
    ' nur bei positivem Test darf plugin bzw. Startbutton aktiviert werden
    '*********************************
Wend
        mDimmerAddr = Int(AddressText)
End Sub


Private Sub cmdHelp_Click()
'displays the help form
   Dim oF As Form
    ' Check, whether form is alrady displayed
    For Each oF In Forms
        If TypeOf oF Is frmAbout Then
           If oF.Caption = "TutorHelp" Then
              oF.Show
              oF.SetFocus
              Exit Sub
           End If
        End If
    Next
    ' Create new form
    Set oF = New frmAbout
    oF.Show
    oF.lblDescription.Caption = "Die 4 Zeilen entsprechen den Kanlen eines Dimmerpacks im Sekundentakt. Der Status kann durch Anklicken der Felder gesetzt werden. Dabei wird mit dem linken Button gewhlt, ob halbe oder volle Helligkeit  verwendet wird. Im Textfeld muss die Startadresse eingegeben werden.                             Mit dem Startbotton wird das Senden der DMX-Werte gestartet. "
End Sub

